/***************************************************************************
 *   Copyright (C) 2004 by James Thorniley                                 *
 *   james@uncommonlygood.co.uk                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DRIVESELECTPAGE_H
#define DRIVESELECTPAGE_H

#include <qwidget.h>
#include <kwizard.h>
#include <kdebug.h>
#include "config.h"

class KListView;
class QVBoxLayout;
class QLabel;
class KProcess;
class KProgress;
class KConfig;
class QTimer;
class ScanBusThread;
class KLineEdit;

/**
@author James Thorniley
*/
class DriveSelectPage : public QWidget
{
Q_OBJECT
public:
    DriveSelectPage(KConfig *config, KWizard *parentWizard, QWidget *parent = 0, const char *name = 0);

    ~DriveSelectPage();
    
    KListView *m_listView;
  private:
    QVBoxLayout *m_layout;
    QLabel *m_instructions1;
    KProcess *m_process;
    KConfig *m_config;
    KWizard *m_wizard;  //parent wizard
    QTimer *m_timer;
    KProgress *m_progress;
    
#ifndef HAVE_K3B
    QLabel *m_instructions2;
    KLineEdit *m_fileInput;
#endif

    ScanBusThread *m_scanBusThread;
    
  public slots:
    void saveSettings();
    
  private slots:
    void enableFinish(){ m_wizard->setFinishEnabled( this, true ); }
    void enableNext(){ m_wizard->setNextEnabled( this, true ); }
    /**If the bus scan is finished, set the UI to display a list of available devices*/
    void checkScanFinished();

    void slotFileInputChanged( const QString &text );

    
  signals:
    void scanFinished();
};

#endif
