/***************************************************************************
 *   Copyright (C) 2004 by James Thorniley                                 *
 *   james@uncommonlygood.co.uk                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KIO_BURNPLUGIN_H
#define KIO_BURNPLUGIN_H

#include <kparts/plugin.h>
#include <klibloader.h>
#include <dcopobject.h>

class ProgressDlg;
namespace KIO { class Job; }

/**
KParts plugin to put cd burning stuff in the toolbar. Big debt to Richard Moore's plugins tutorial 
(http://developer.kde.org/documentation/tutorials/dot/writing-plugins.html)

@author James Thorniley
*/
class kio_burnPlugin : public KParts::Plugin, virtual public DCOPObject
{
Q_OBJECT
K_DCOP
public:
    kio_burnPlugin(QObject *parent = 0, const char *name = 0);

    ~kio_burnPlugin();
    

  k_dcop:
      
      ASYNC showProgressBar( bool show );
      ASYNC setProgressBarText(QString text );
      ASYNC setProgressBarValue( int value );
      ASYNC setProgressBarTotal( int total );
      
  protected slots:
    void startBurn();
    void burnResult( KIO::Job *job );
    
  protected:
    ProgressDlg *m_progress;
    
};

class KPluginFactory : public KLibFactory
{
  Q_OBJECT
  public:
    KPluginFactory( QObject *parent = 0, const char *name = 0 );
    ~KPluginFactory() { delete s_instance; };


    virtual QObject* createObject( QObject* parent = 0, const char* pname = 0,
                             const char* name = "QObject",
                             const QStringList &args = QStringList() );

  private:
    static KInstance* s_instance;
};
#endif
