/***************************************************************************
 *   Copyright (C) 2005 by James Thorniley                                 *
 *   james@uncommonlygood.co.uk                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "settingswizard.h"
#include "driveselectpage.h"

#include <klocale.h>
#include <kpushbutton.h>
#include <klistview.h>
#include <qevent.h>
#include <qapplication.h>

SettingsWizard::SettingsWizard(KConfig *config, QWidget *parent, const char *name )
 : KWizard(parent, name, true)
{
  m_settingsPage = new DriveSelectPage(config,this);
  
  addPage( m_settingsPage, i18n("Select device" ) );
  
  connect( finishButton(), SIGNAL( clicked() ),
           m_settingsPage, SLOT( saveSettings() ) );
  connect( m_settingsPage->m_listView, SIGNAL( selectionChanged() ),
           m_settingsPage, SLOT( enableFinish() ) );
  
  setFinishEnabled( m_settingsPage, false );
  setHelpEnabled( m_settingsPage, false );

  setCaption(i18n("Settings" ) );
}

void SettingsWizard::closeEvent( QCloseEvent *e )
{
  e->accept();
  qApp->exit_loop();
}

SettingsWizard::~SettingsWizard()
{
}


#include "settingswizard.moc"
